package edu.dhbw.ma.pv;

public class MultTransposeMatrix extends Matrix {
    public MultTransposeMatrix(double[][] d) {
	super(d);
    }

    public Matrix multiply(Matrix B) {
	double[][] res = new double[val.length][val[0].length];
	Matrix Bt = B.transpose();
	double[][] Bval = Bt.val; 
	for (int i = 0; i < val.length; i++) {
	    for (int j = 0; j < val[0].length; j++) {
		double s = 0.0;
		for (int k = 0; k < Bval[0].length; k++ ) {
		    s += val[i][k] * Bval[j][k]; // k,j
		}
		res[i][j] = s; 
	    }
	}
	return new Matrix(res);
    }	
}
