package edu.dhbw.ma.pv;

public class Uebung1 {

    public static void main(String[] args) {
	int t = 10;
	int arbeit = 1000000;
	Thread[] threads = new Thread[t];
	for (int i = 0; i < t; i++ ) {
	    threads[i] = new Thread( new Faden(i,arbeit) );
	}
	System.out.println("Threads created.");
        for (int i = 0; i < t; i++ ) {
	    threads[i].start();
        }
        System.out.println("Threads started.");
        for (int i = 0;i < t; i++ ) {
	    try {
		threads[i].join();
	    } catch (InterruptedException e) {
		e.printStackTrace();
	    }
        }
        System.out.println("Threads terminated.");
        // no no: System.exit(0);
    }
}

class Faden implements Runnable {
 
    int anzahl;
    int mynumber;
    
    public Faden(int m, int a) {
	mynumber = m;
	anzahl = a;
    }
	
    @Override
    public void run() {
	System.out.println("Hallo von Thread Faden(" + mynumber +")");
        double s = 0.0;
	for (int i = 0; i < anzahl; i++) {
	    s += Math.sin(i);
	}
	System.out.println("Thread Faden(" + mynumber + ") beendet: s = " + s);
    }
}
