package edu.dhbw.ma.pv;

public class Uebung1a {

    public static void main(String[] args) {
	int t = 10;
	int arbeit = 1000000;
	ThFaden[] threads = new ThFaden[t];
	for (int i = 0; i < t; i++ ) {
	    threads[i] = new ThFaden(i,arbeit);
	}
	System.out.println("Threads created.");
        for (int i = 0; i < t; i++ ) {
	    threads[i].start();
        }
        System.out.println("Threads started.");
        for (int i = 0;i < t; i++ ) {
	    try {
		threads[i].join();
	    } catch (InterruptedException e) {
		e.printStackTrace();
	    }
        }
        System.out.println("Threads terminated.");
        double gesammt = 0.0;
        for (int i = 0; i < t; i++ ) {
	    gesammt += threads[i].s;
        }
        System.out.println("gesammte Summe = " + gesammt);
        // no no: System.exit(0);
    }
}

class ThFaden extends Thread { //implements Runnable {
 
    int anzahl;
    int mynumber;
    double s = 0.0;
    
    public ThFaden(int m, int a) {
	mynumber = m;
	anzahl = a;
    }
	
    @Override
    public void run() {
	System.out.println("Hallo von Thread Faden(" + mynumber +")");
	for (int i = 0; i < anzahl; i++) {
	    s += Math.sin(i);
	}
	System.out.println("Thread Faden(" + mynumber + ") beendet: s = " + s);
    }
}
