package edu.dhbw.ma.pv;

public class Uebung2 {

    public static void main(String[] args) {
	int t = 10000;
	int arbeit = 1000;
	ThFaden2[] threads = new ThFaden2[t];
	for (int i = 0; i < t; i++ ) {
	    threads[i] = new ThFaden2(i,arbeit);
	}
	System.out.println("Threads created.");
	long time = System.currentTimeMillis();
	for (int i = 0; i < t; i++ ) {
	    threads[i].start();
	}
	System.out.println("Threads started.");
	for (int i = 0;i < t; i++ ) {
	    try {
		threads[i].join();
		//System.out.println("sync sum = " + ThFaden2.getSum());
	    } catch (InterruptedException e) {
		e.printStackTrace();
	    }
	}
	System.out.println("Threads terminated.");
	time = System.currentTimeMillis() - time;
	double gesammt = 0.0;
	for (int i = 0; i < t; i++ ) {
	    gesammt += threads[i].s;
	}
	System.out.println("gesammte Summe = " + gesammt);
	System.out.println("synchronisierte gesammte Summe = " + ThFaden2.getSum());
	System.out.println("Zeit " + time + " milliseconds");
	// no no: System.exit(0);
    }
}

class ThFaden2 extends Thread { //implements Runnable {

    static double gsum = 0.0;
    int anzahl;
    int mynumber;
    double s = 0.0;

    public ThFaden2(int m, int a) {
	mynumber = m;
	anzahl = a;
    }

    @Override
    public void run() {
	System.out.println("Hallo von Thread Faden(" + mynumber +")");
	for (int i = 0; i < anzahl; i++) {
	    double x = Math.sin(i);
	    s += x;
	    //addToSum(x);
	}
	System.out.println("Thread Faden(" + mynumber + ") beendet: s = " + s);
	addToSum(s);
    }
    static synchronized void addToSum(double s) {
	double x = gsum + s;
	gsum = x;
    }
    static synchronized double getSum() {
	return gsum;
    }
}

