package edu.dhbw.pv;

import jomp.runtime.OMP;

public class Aufgabe9 {


   public static void main(String[] args) {
        
        System.out.println("running on " + OMP.getThreadNum());
        int anzahl = 10000000;
        double summe = 0.0;
        long ts = System.currentTimeMillis();
        for (int i = 0; i < anzahl; i++) {
             summe += Math.cos( (double)i );
        }
        ts = System.currentTimeMillis() - ts;

// OMP PARALLEL BLOCK BEGINS
{
  __omp_Class0 __omp_Object0 = new __omp_Class0();
  // shared variables
  __omp_Object0.ts = ts;
  __omp_Object0.summe = summe;
  __omp_Object0.anzahl = anzahl;
  __omp_Object0.args = args;
  // firstprivate variables
  try {
    jomp.runtime.OMP.doParallel(__omp_Object0);
  } catch(Throwable __omp_exception) {
    System.err.println("OMP Warning: Illegal thread exception ignored!");
    System.err.println(__omp_exception);
  }
  // reduction variables
  // shared variables
  ts = __omp_Object0.ts;
  summe = __omp_Object0.summe;
  anzahl = __omp_Object0.anzahl;
  args = __omp_Object0.args;
}
// OMP PARALLEL BLOCK ENDS


        System.out.println("seq time = " + ts);
        System.out.println("summe = " + summe);

        summe = 0.0;
        long tp = System.currentTimeMillis();

// OMP PARALLEL BLOCK BEGINS
{
  __omp_Class1 __omp_Object1 = new __omp_Class1();
  // shared variables
  __omp_Object1.summe = summe;
  __omp_Object1.tp = tp;
  __omp_Object1.ts = ts;
  __omp_Object1.anzahl = anzahl;
  __omp_Object1.args = args;
  // firstprivate variables
  try {
    jomp.runtime.OMP.doParallel(__omp_Object1);
  } catch(Throwable __omp_exception) {
    System.err.println("OMP Warning: Illegal thread exception ignored!");
    System.err.println(__omp_exception);
  }
  // reduction variables
  // shared variables
  summe = __omp_Object1.summe;
  tp = __omp_Object1.tp;
  ts = __omp_Object1.ts;
  anzahl = __omp_Object1.anzahl;
  args = __omp_Object1.args;
}
// OMP PARALLEL BLOCK ENDS

        tp = System.currentTimeMillis() - tp;
        System.out.println("summe = " + summe);
        
        System.out.println("seq time = " + ts);
        System.out.println("par time = " + tp);
    }

// OMP PARALLEL REGION INNER CLASS DEFINITION BEGINS
private static class __omp_Class1 extends jomp.runtime.BusyTask {
  // shared variables
  double summe;
  long tp;
  long ts;
  int anzahl;
  String [ ] args;
  // firstprivate variables
  // variables to hold results of reduction

  public void go(int __omp_me) throws Throwable {
  // firstprivate variables + init
  // private variables
  // reduction variables, init to default
    // OMP USER CODE BEGINS

                  { // OMP FOR BLOCK BEGINS
                  // copy of firstprivate variables, initialized
                  // copy of lastprivate variables
                  // variables to hold result of reduction
                  double _cp_summe;
                  boolean amLast=false;
                  {
                    // firstprivate variables + init
                    // [last]private variables
                    // reduction variables + init to default
                    double  summe = 0;
                    // -------------------------------------
                    jomp.runtime.LoopData __omp_WholeData3 = new jomp.runtime.LoopData();
                    jomp.runtime.LoopData __omp_ChunkData2 = new jomp.runtime.LoopData();
                    __omp_WholeData3.start = (long)( 0);
                    __omp_WholeData3.stop = (long)( anzahl);
                    __omp_WholeData3.step = (long)(1);
                    jomp.runtime.OMP.setChunkStatic(__omp_WholeData3);
                    while(!__omp_ChunkData2.isLast && jomp.runtime.OMP.getLoopStatic(__omp_me, __omp_WholeData3, __omp_ChunkData2)) {
                    for(;;) {
                      if(__omp_WholeData3.step > 0) {
                         if(__omp_ChunkData2.stop > __omp_WholeData3.stop) __omp_ChunkData2.stop = __omp_WholeData3.stop;
                         if(__omp_ChunkData2.start >= __omp_WholeData3.stop) break;
                      } else {
                         if(__omp_ChunkData2.stop < __omp_WholeData3.stop) __omp_ChunkData2.stop = __omp_WholeData3.stop;
                         if(__omp_ChunkData2.start > __omp_WholeData3.stop) break;
                      }
                      for(int i = (int)__omp_ChunkData2.start; i < __omp_ChunkData2.stop; i += __omp_ChunkData2.step) {
                        // OMP USER CODE BEGINS
 {
             summe += Math.cos( (double)i );
        }
                        // OMP USER CODE ENDS
                        if (i == (__omp_WholeData3.stop-1)) amLast = true;
                      } // of for 
                      if(__omp_ChunkData2.startStep == 0)
                        break;
                      __omp_ChunkData2.start += __omp_ChunkData2.startStep;
                      __omp_ChunkData2.stop += __omp_ChunkData2.startStep;
                    } // of for(;;)
                    } // of while
                    // call reducer
                    _cp_summe = (double) jomp.runtime.OMP.doPlusReduce(__omp_me, summe);
                    jomp.runtime.OMP.doBarrier(__omp_me);
                    // copy lastprivate variables out
                    if (amLast) {
                    }
                  }
                  // set global from lastprivate variables
                  if (amLast) {
                  }
                  // set global from reduction variables
                  if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
                    summe+= _cp_summe;
                  }
                  } // OMP FOR BLOCK ENDS

    // OMP USER CODE ENDS
  // call reducer
  // output to _rd_ copy
  if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
  }
  }
}
// OMP PARALLEL REGION INNER CLASS DEFINITION ENDS



// OMP PARALLEL REGION INNER CLASS DEFINITION BEGINS
private static class __omp_Class0 extends jomp.runtime.BusyTask {
  // shared variables
  long ts;
  double summe;
  int anzahl;
  String [ ] args;
  // firstprivate variables
  // variables to hold results of reduction

  public void go(int __omp_me) throws Throwable {
  // firstprivate variables + init
  // private variables
  // reduction variables, init to default
    // OMP USER CODE BEGINS

        {
           int me = OMP.getThreadNum();
           System.out.println("Hallo Welt von " + me);
        }
    // OMP USER CODE ENDS
  // call reducer
  // output to _rd_ copy
  if (jomp.runtime.OMP.getThreadNum(__omp_me) == 0) {
  }
  }
}
// OMP PARALLEL REGION INNER CLASS DEFINITION ENDS

}

