

/**
 * A Path in a Graph
 */

public interface Path {

    /**
     * empty path, all n points unused.

    public static Path emptyPath(Graph g);
     */


    /**
     * standard path from point 0 to point n-1 to 0.

    public static Path standardPath(Graph g); 
     */


    /**
     * get array of next possible paths.
     */

    public Path[] nextPaths();


    public String toString();


    public int length();


    public int maxsize();


    public double cost();


    // protected static double cost(double c);

}