package edu.dhbw.pv;

public class Aufgabe3 { 

    public static void main(String[] args) {
        int n = 1200;
        int m = n;
        System.out.println("size = " + n + " x " + m);
        Matrix A = new Matrix(n,m, true);
        Matrix B = new Matrix(n,m, false);
        //System.out.println("A = \n" + A);
        //System.out.println("B = \n" + B);
        
        long t = System.currentTimeMillis();
        Matrix C = A.multiply(B);
        t = System.currentTimeMillis() - t;
        //System.out.println("C = \n" + C);
        System.out.println("B == C: " + B.equals(C) );
     
        ParallelMatrix Ap = new ParallelMatrix(A.val);
        long tp = System.currentTimeMillis();
        Matrix Cv = Ap.multiply(B);
        tp = System.currentTimeMillis() - tp;
        System.out.println("B == Cv: " + B.equals(Cv) );
    
        TransposeMatrix At = new TransposeMatrix(A.val);
        long tt = System.currentTimeMillis();
        Matrix Ct = At.multiply(B);
        tt = System.currentTimeMillis() - tt;
        System.out.println("B == Ct: " + B.equals(Ct) );
    
        ParallelTransposeMatrix Apt = new ParallelTransposeMatrix(A.val);
        long tpt = System.currentTimeMillis();
        Matrix Cpt = Apt.multiply(B);
        tpt = System.currentTimeMillis() - tpt;
        System.out.println("B == Cpt: " + B.equals(Cpt) );
    
        System.out.println("sequenziel:            " + t);
        System.out.println("parallel:              " + tp);
        System.out.println("transponiert:          " + tt);
        System.out.println("parallel transponiert: " + tpt);
    }

}
