package edu.dhbw.pv;

import java.util.Random;
import java.util.stream.Stream;
import java.util.stream.DoubleStream;
import java.util.concurrent.ThreadLocalRandom;

public class Aufgabe6 {

    public static void main(String[] args) {
        int anzahl = 1_000_000_000;
        DoubleStream randoms = ThreadLocalRandom.current().doubles(anzahl);
        //Stream<Double> randoms = ThreadLocalRandom.current().doubles(anzahl).boxed();
        System.out.println("randoms = " + randoms);
        System.out.println("elemente ");
        //randoms.forEach( d -> System.out.print(d + " ") );
        System.out.println();
        Random rand = new Random();

        //DoubleStream neue = randoms.filter( d -> d >= 0.5 ); 
        // rand.nextDouble(); 
        long ts = System.currentTimeMillis(); 
        long imKreis = randoms.filter( x -> { double y = ThreadLocalRandom.current().nextDouble();
                                              return x*x + y*y < 1.0; } )
                              .count();
        ts = System.currentTimeMillis() - ts;
        System.out.println("imKreis = " + imKreis + ", anzahl = " + anzahl);
        double pi = (double)imKreis/(double)anzahl * 4.0;
        System.out.println("pi = " + pi);

        randoms = ThreadLocalRandom.current().doubles(anzahl).parallel();
        // rand.nextDouble(); 
        long tp = System.currentTimeMillis();
        imKreis = randoms.filter( x -> { double y = ThreadLocalRandom.current().nextDouble();
                                         return x*x + y*y < 1.0; } )
                         .count();
        tp = System.currentTimeMillis() - tp;

        System.out.println("imKreis = " + imKreis + ", anzahl = " + anzahl);
        pi = (double)imKreis/(double)anzahl * 4.0;
        System.out.println("pi = " + pi);

        System.out.println("sequential = " + ts);
        System.out.println("parallel   = " + tp);
    }

}
