package edu.dhbw.pv;

public class Semaphore {
    int s = 0; // s >= 0
    Object mux = new Object();
    public Semaphore(int i) {
    	s = Math.abs(i);
    }
    public /*synchronized*/ void aquire() throws InterruptedException { // P()
        synchronized (mux) { 
            while (s <= 0) {
                mux.wait();
            }  
            s--;
        }
    }
	
    public /*synchronized*/ void release() { // V()
        synchronized (mux) { 
            s++;
            if (s > 0) {
                mux.notify(); // this ... All
            }
        }
    }
}
