package edu.dhbw.ma.pv;

public class MatrixMain {

    public static void main(String[] args) {
	int n = 1000; 
	int m = n;
	//Matrix A = Matrix.genOne(n, m);
	//Matrix A = Matrix.genZero(n,m);
	Matrix A = Matrix.genRandom(n, m);
	Matrix B = Matrix.genRandom(n, m);

	long ts = System.currentTimeMillis();
	Matrix C = A.multiply(B);
	ts = System.currentTimeMillis() - ts; 

	ParallelMatrix Ap = new ParallelMatrix(A.val);
	long tp = System.currentTimeMillis();
	Matrix Cp = Ap.multiply(B);
	tp = System.currentTimeMillis() - tp;

	MultTransposeMatrix At = new MultTransposeMatrix(A.val);
	long tt = System.currentTimeMillis();
	Matrix Ct = At.multiply(B);
	tt = System.currentTimeMillis() - tt;
		
	ParallelTransMatrix Apt = new ParallelTransMatrix(A.val);
	long tpt = System.currentTimeMillis();
	Matrix Cpt = Apt.multiply(B);
	tpt = System.currentTimeMillis() - tpt;

	Matrix D = C.difference(B);
	Matrix Dp = Cp.difference(B);

	Matrix S = C.difference(Cp);
		
//		System.out.println("A = " + A);
//		System.out.println("B = " + B);
//		System.out.println("C = " + C);
//		System.out.println("Cp = " + Cp);
//		System.out.println("D = " + D);
//		System.out.println("Dp = " + Dp);
		
	System.out.println("C = A*B: " + D.isNearlyZero());
	System.out.println("Cp = Ap*B: " + Dp.isNearlyZero());
	System.out.println("C = Cp: " + S.isNearlyZero());
	System.out.println("ts  = " + ts);
	System.out.println("tp  = " + tp);
	System.out.println("tt  = " + tt);
	System.out.println("tpt = " + tpt);
    }
}
