package edu.dhbw.ma.pv;

public class Semaphore {

    private int s;
    private int wartend;
    private int init;
        
    public Semaphore(int i) {
        if ( i >= 0 ) {
            init = i;
        } else {
            init = 0;
        }
        s = init;
    }
    public synchronized void aquire() throws InterruptedException {
        while (s <= 0) { // if
            wartend++;
            this.wait();
            wartend--;
        }
        s--;
    }
    public synchronized void release() {
        s++;
        if (wartend > 0) {
            this.notifyAll();
        }
    }
    public /*synchronized*/ String toString() {
        return "Semaphore(" + s + "/" + init + ",w=" + wartend  + ")";
    }
}
