package edu.dhbw.ma.pv;

public class Uebung3 {

    final static int anzahl = 100;
    public static void main(String[] args) {
        Semaphore sem = new Semaphore(anzahl/2); // 0, 1, 10
        //sem.release();
        Thread[] threads = new Thread[anzahl]; 
        for (int i =0; i < anzahl; i++) { 
            threads[i] = new Thread( new SemUebung3(i,sem) );
            threads[i].start();
        }
        for (int i = 0; i < anzahl; i++) {
            try {
                threads[i].join();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
}
class SemUebung3 implements Runnable {
    Semaphore sem;
    int mynumber;
    public SemUebung3(int i, Semaphore s) {
        sem = s;
        mynumber = i;
    }
    public void run () {
        System.out.println("started " + this);
        try {
            sem.aquire();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        System.out.println("Semaphore erhalten");
        try {
            Thread.sleep((int)(Math.random()*100));
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        sem.release();
        System.out.println("terminated " + this);
    }
    public String toString() {
        return "SemUebung3(" + mynumber + "," + sem + ")";
    }
}
