package edu.dhbw.pv;

public class Uebung3 {

    public static void main(String[] args) {
        int n = 1500;
        int m = n;

        Matrix zero = new Matrix(n, m);
        Matrix one = Matrix.one(n, m);
        Matrix A = Matrix.random(n, m);
        
        //System.out.println("zero = \n" + zero);
        // System.out.println("one = \n" + one);
        //System.out.println("A = \n" + A);
        
        long t = System.currentTimeMillis() ;
        Matrix C = A.multiply(one);
        t = System.currentTimeMillis() - t;
        //System.out.println("C = \n" + C);
        System.out.println("A == C: " + A.equals(C));

        ParallelMatrix Ap = new ParallelMatrix(A.val);
        long tp = System.currentTimeMillis();
        Matrix Cp = Ap.multiply(one);
        tp = System.currentTimeMillis() - tp;
        //System.out.println("Cp = \n" + Cp);
        System.out.println("C == Cp: " + C.equals(Cp));
  
        MatrixTrans At = new MatrixTrans(A.val);
        long tt = System.currentTimeMillis();
        Matrix Ct = At.multiply(one);
        tt = System.currentTimeMillis() - tt;
        System.out.println("C == Ct: " + C.equals(Ct));
         
        ParallelMatrixTrans Apt = new ParallelMatrixTrans(A.val);
        long tpt= System.currentTimeMillis();
        Matrix Cpt = Apt.multiply(one);
        tpt = System.currentTimeMillis() - tpt;
        System.out.println("C == Cpt: " + C.equals(Cpt));
        
        System.out.println("sequential            = " + t);
        System.out.println("parallel              = " + tp);
        System.out.println("sequential transpose  = " + tt);
        System.out.println("parallel transpose    = " + tpt);
    }

}
