package edu.dhbw.pv;

import mpi.MPI;
import mpi.Status;

public class Aufgabe8 {

    public static void main(String[] args) {
        MPI.Init(args);

        int size = MPI.COMM_WORLD.Size();
        int me = MPI.COMM_WORLD.Rank();
        System.out.println("Hallo! ich bin " + me + " von " + size);
        int[] puffer = new int[10];
        int summe = 0;
        if (me == 0) {
            System.out.println("Hier ist Nummer 0.");
            for (int i = 0; i < puffer.length; i++) {
                puffer[i] = i*i;
            }
        }    
        MPI.COMM_WORLD.Bcast(puffer, 0, puffer.length, MPI.INT, 0);    
        if (me != 0) {
            for (int i = 0; i < puffer.length; i++) {
                summe += puffer[i];
            }
            System.out.println("summe = " + summe + " in " + me);
            puffer[0] = summe;
        }
        int[] rbuf = new int[1];
        MPI.COMM_WORLD.Reduce(puffer, 0, rbuf, 0, 1, MPI.INT, MPI.SUM, 0);
        //no: MPI.COMM_WORLD.Reduce(puffer, 0, puffer, 1, 1, MPI.INT, MPI.SUM, 0);
        if (me == 0) {
            System.out.println("totale summe = " + rbuf[0]);
        }
        
        MPI.Finalize();
    }
}
