package edu.dhbw.pv;

public class Aufgabe1 {
    public static double globaleSumme = 0.0;
	public static void main(String[] args) {
		int N = 100000000;
		int t = 10; 
		Thread[] threads = new Thread[t];
		Summe1[] sums = new Summe1[t];
		for (int i = 0; i < t; i++) {
			sums[i] = new Summe1(N, i, t );
			threads[i] = new Thread(sums[i] );
			threads[i].start();
		}
		for (int i = 0; i < t; i++){
			try {
				threads[i].join();
				globaleSumme += sums[i].summe;
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		System.out.println("Summe = " + globaleSumme);
	}
	
}

class Summe1 implements Runnable {
	int thread;
	int noThreads;
	int N;
	double summe = 0.0;
	public Summe1(int n, int th, int nt) {
		N = n;
		thread = th;
		noThreads = nt;
	}
	public void run() {
		System.out.println("started thread " + thread + " of " + noThreads);
		//double summe = 0.0;
		for (int i = thread; i < N; i += noThreads) {
			//if (thread == 0) System.exit(0);
			summe += Math.sin(2.0*i);
			//synchronized (Aufgabe1.class) { Aufgabe1.globaleSumme += Math.sin(2.0*i);} 
		}
		System.out.println("ended thread " + thread + ", lokale summe = " + summe);
		//synchronized (Aufgabe1.class) { Aufgabe1.globaleSumme += summe; }
	}
}